# coding: utf-8

"""
    Orbit Determination API

    Orbit Determination API

    The version of the OpenAPI document: 1.3.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class KalmanReflectivityCoefficientEstimationRequest(BaseModel):
    """
    Request for computing reflectivity coefficient estimation with Unscented Kalman Filter. With an isotropic space object, it is directly the specular reflection coefficient or the single radiation one that is estimated. For a box on the other hand, it is a multiplicative factor applying on the solar radiation force as the latter depends on all the blocks of the object (sides and solar array)
    """ # noqa: E501
    standard_deviation: Union[Annotated[float, Field(le=10, strict=True, ge=0)], Annotated[int, Field(le=10, strict=True, ge=0)]] = Field(description="Same units than the quantity being estimated", alias="standardDeviation")
    process_noise_standard_deviation: Optional[Union[Annotated[float, Field(le=10, strict=True, ge=0)], Annotated[int, Field(le=10, strict=True, ge=0)]]] = Field(default=0.0, description="Only used for estimations with sequential filters. Same units than the quantity being estimated", alias="processNoiseStandardDeviation")
    __properties: ClassVar[List[str]] = ["standardDeviation", "processNoiseStandardDeviation"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of KalmanReflectivityCoefficientEstimationRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of KalmanReflectivityCoefficientEstimationRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "standardDeviation": obj.get("standardDeviation"),
            "processNoiseStandardDeviation": obj.get("processNoiseStandardDeviation") if obj.get("processNoiseStandardDeviation") is not None else 0.0
        })
        return _obj


