# coding: utf-8

"""
    Orbit Determination API

    Orbit Determination API

    The version of the OpenAPI document: 1.3.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from spacetower_orbit_determination_python_client.models.local_frame_based_finite_thrust_sequence import LocalFrameBasedFiniteThrustSequence
from spacetower_orbit_determination_python_client.models.maneuver_schedule import ManeuverSchedule
from spacetower_orbit_determination_python_client.models.maneuver_schedule_type import ManeuverScheduleType
from spacetower_orbit_determination_python_client.models.rotating_local_frame_id import RotatingLocalFrameId
from typing import Optional, Set
from typing_extensions import Self

class LocalFrameBasedManeuverSchedule(ManeuverSchedule):
    """
    Maneuver schedule defined in a local frame. No thruster is required
    """ # noqa: E501
    local_frame_id: RotatingLocalFrameId = Field(alias="localFrameId")
    local_frame_based_finite_thrust_sequence: Optional[LocalFrameBasedFiniteThrustSequence] = Field(default=None, alias="localFrameBasedFiniteThrustSequence")
    __properties: ClassVar[List[str]] = ["maneuverScheduleType", "localFrameId", "localFrameBasedFiniteThrustSequence"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LocalFrameBasedManeuverSchedule from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of local_frame_based_finite_thrust_sequence
        if self.local_frame_based_finite_thrust_sequence:
            _dict['localFrameBasedFiniteThrustSequence'] = self.local_frame_based_finite_thrust_sequence.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LocalFrameBasedManeuverSchedule from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "maneuverScheduleType": obj.get("maneuverScheduleType"),
            "localFrameId": obj.get("localFrameId"),
            "localFrameBasedFiniteThrustSequence": LocalFrameBasedFiniteThrustSequence.from_dict(obj["localFrameBasedFiniteThrustSequence"]) if obj.get("localFrameBasedFiniteThrustSequence") is not None else None
        })
        return _obj


