# coding: utf-8

"""
    Orbit Determination API

    Orbit Determination API

    The version of the OpenAPI document: 1.3.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from importlib import import_module
from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional, Union
from spacetower_orbit_determination_python_client.models.measurement_type import MeasurementType
from typing import Optional, Set
from typing_extensions import Self

from typing import TYPE_CHECKING
if TYPE_CHECKING:
    from spacetower_orbit_determination_python_client.models.gps_nmea_measurements import GpsNmeaMeasurements
    from spacetower_orbit_determination_python_client.models.position_measurements import PositionMeasurements
    from spacetower_orbit_determination_python_client.models.position_velocity_measurements import PositionVelocityMeasurements

class Measurements(BaseModel):
    """
    Generic dated-weighted measurement series with field descriptions
    """ # noqa: E501
    measurement_type: MeasurementType = Field(alias="measurementType")
    dates: Optional[List[str]] = None
    __properties: ClassVar[List[str]] = ["measurementType", "dates"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    # JSON field name that stores the object type
    __discriminator_property_name: ClassVar[str] = 'measurementType'

    # discriminator mappings
    __discriminator_value_class_map: ClassVar[Dict[str, str]] = {
        'GPS_NMEA': 'GpsNmeaMeasurements','POSITION': 'PositionMeasurements','POSITION_VELOCITY': 'PositionVelocityMeasurements'
    }

    @classmethod
    def get_discriminator_value(cls, obj: Dict[str, Any]) -> Optional[str]:
        """Returns the discriminator value (object type) of the data"""
        discriminator_value = obj[cls.__discriminator_property_name]
        if discriminator_value:
            return cls.__discriminator_value_class_map.get(discriminator_value)
        else:
            return None

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Union[GpsNmeaMeasurements, PositionMeasurements, PositionVelocityMeasurements]]:
        """Create an instance of Measurements from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict[str, Any]) -> Optional[Union[GpsNmeaMeasurements, PositionMeasurements, PositionVelocityMeasurements]]:
        """Create an instance of Measurements from a dict"""
        # look up the object type based on discriminator mapping
        object_type = cls.get_discriminator_value(obj)
        if object_type ==  'GpsNmeaMeasurements':
            return import_module("spacetower_orbit_determination_python_client.models.gps_nmea_measurements").GpsNmeaMeasurements.from_dict(obj)
        if object_type ==  'PositionMeasurements':
            return import_module("spacetower_orbit_determination_python_client.models.position_measurements").PositionMeasurements.from_dict(obj)
        if object_type ==  'PositionVelocityMeasurements':
            return import_module("spacetower_orbit_determination_python_client.models.position_velocity_measurements").PositionVelocityMeasurements.from_dict(obj)

        raise ValueError("Measurements failed to lookup discriminator value from " +
                            json.dumps(obj) + ". Discriminator property name: " + cls.__discriminator_property_name +
                            ", mapping: " + json.dumps(cls.__discriminator_value_class_map))


